# mulesoft Design Center - Full Documentation
---
product: Design Center
---
# About Design Center
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
Anypoint Design Center is a development environment that includes
[API Designer](https://docs.mulesoft.com/design-center/design-create-publish-api-specs), a tool that enables you to create API
specifications in several modeling languages and create RAML API fragments. After you create a
specification or fragment, publish it to Anypoint Exchange for anyone in your MuleSoft organization
to use.
> [!NOTE] Flow Designer is
> [end of life](https://www.salesforce.com/en-us/wp-content/uploads/sites/4/documents/legal/Agreements/versioning-back-support-policy.pdf)
> and its documentation is now located at
> [Flow Designer archive site](https://archive.docs.mulesoft.com/design-center/index).
## Prerequisites for Using Design Center
You must meet the following requirements for accessing Design Center, using its features, running
and deploying apps, and publishing designs to Exchange:
- Be assigned the Design Center Developer permission or be the Organization Owner.
- Be assigned the CloudHub Admin role for the Design environment.
- Be assigned the Exchange Contributor role.
- Belong to an Anypoint organization that has at least one CloudHub Design Environment with 0.2
vCores of available capacity.
To deploy to the production environment from Design Center, your user account also needs to be
assigned to a CloudHub Developer role specifically for the production environment.
## Where to Start Using Design Center
To start using Design Center, click Design Center after signing into Anypoint Platform. The Projects
list appears. See the documentation for API Designer for the steps to create projects for those
tools.
## See Also
- [Roles](https://docs.mulesoft.com/access-management/roles)
- [CloudHub Environments](https://docs.mulesoft.com/access-management/environments)
---
product: Design Center
---
# Add Behavioral Headers to Simulated API Calls
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
Behavioral headers enable you to change the behavior of the mocking service. Use behavioral headers
where you would normally specify other types of header when simulating requests to API
specifications.
## MS2-Delay
MS2-Delay indicates how many milliseconds the request should take to answer. You might want to use
this header to simulate load on your server or latency in a network.
You can specify a value for this header as an integer or as a range of integers. If you specify a
range, the value must have the form `min-max`. For example, given the value `500-1000`, the request
will take a random time between 500 and 1000 milliseconds.
> [!NOTE] It is possible for the delay to be longer than a single integer value or the high end of a
> range, depending on the latency of your network.
The MS2-Delay takes a maximum value of 10000 milliseconds (ms), and follows this behavior:
- If the value is set to less than 10000 ms, the mocking service adds a delay of ~5000 ms.
- If the value is set to greater than 10000 ms, the mocking service adds a delay of ~10000 ms.
Examples: \* If the value is set to a range of 5000 - 9000 ms, the mocking service adds a delay of
~5000 - ~9000 ms. \* If the value is set to a range of 9000 - 20000 ms, the mocking service adds a
delay of ~9000 - ~10000 ms. \* If the value is set to a range of 20000 - 30000 ms, the mocking
service returns this error message:
{ "code": "INVALID\_HEADER\_VALUE", "message": "Invalid value for header MS2-Delay. Requested range
is higher than the max value allowed: 10000 ms" }
## MS2-Example
The MS2-Example header enables you to choose a specific response example if your endpoint defines
more than one example for a single status code.
Using MS2-Example, you can specify multiple examples within a response. This example shows three
examples for the status code 200:
/examples: get: responses: 200: body: application/json: examples: one: prop1: something prop2: 30
two: prop1: another prop2: 31 three: prop1: anything prop2: 33
Here, the possible values of the header would be `one`, `two`, and `three`. Sending the value `one`
as part of the request would return the payload `something` and `30`. Sending a value other than
`one`, `two`, or `three` would return an error message.
## MS2-Error-Level
MS2-Error-Level indicates which range of error status codes the mocking service is restricted to
using. You can specify one of the following three case-sensitive values:
- `REQUEST_ONLY`: The mocking service uses only 4XX codes.
- `SERVER_ONLY`: The mocking service uses only 5XX codes.
- `ALL`: The mocking service can use both 4XX and 5XX codes. This is the default value.
## MS2-Error-Rate
MS2-Error-Rate indicates the probability of getting an error status code as a response. The value
for this header must be a decimal between 0 and 1.
This header works together with MS2-Status-Code, MS2-Error-Level, or both at the same time.
Table 1. How the mocking service determines which status code to respond with when you use MS2-Error-Rate | Other header used with MS2-Error-Rate | Mocking service (MS) responds with an error code | Mocking service does not respond with an error code |
|---|
MS2-Status-Code | MS uses the error code specified in MS2-Status-Code. | MS uses the non-error status code specified in MS2-Status-Code. |
MS2-Error-Level | MS uses the first error status code that is defined for the method and that falls in the range specified for MS2-Error-Level. | MS uses the first non-error status code that is defined for the method. |
MS2-Error-Level and MS2-Status-Code | MS uses the first error status code that is defined for the method and that falls in the range specified for MS2-Error-Level. | MS uses the first non-error status code that is specified in MS2-Status-Code. |
None | MS uses the first error status code that is defined for the method. | MS uses the first non-error status code that is defined for the method. |
## MS2-Randomize
When MS2-Randomize is set to `true`, the mocking service auto-generates a payload response if no
example is defined for the response.
For example, suppose that an API specification contained the definitions of this type:
types: Person: properties: id: integer name: string
If you did not provide an example, but you used the header MS2-Randomize, set to `true`, with the
mocking service, the payload of the returned message would contain an example with random values
that matched the data types, like this:
{ "id": 98358, "name": "OVCKr" }
Moreover, the header supports more detailed definition of types. For example, you might change your
type definition to look like this:
types: Person: properties: id: type: integer minimum: 3 maximum: 30 multipleOf: 3 name: string
If MS2-Randomize were set to `true`, the payload in the response from the mocking service might look
like this, with the value of `id` conforming to the constraints:
{ "id": 9, "name": "rul68" }
## MS2-Status-Code
MS2-Status-Code specifies the status code or codes that the mocking service can choose from for the
return message. This header behaves as a filter on the list of status codes that are defined for a
method. For example, suppose a method has several non-error status codes defined; if you wanted the
mocking service to respond with only one of those status codes, you would specify it with this
header.
> [!IMPORTANT] If you use this header together with MS2-Error-Rate, you must specify both a
> non-error status code and an error status code. Separate the two status codes with a comma. For
> example, you might want the mocking service to return a 201 message, if there is no error, or a
> 401 status code, if there is an error; in this case, you would specify `201,401` for the value.
## MS2-Status-Code-Selection
By default, when the mocking service responds to a request, it chooses the minimum status code that
is defined for the corresponding method. For example, if you make a POST request to an endpoint that
defines responses for status codes 201, 400, 409, and 500, by default the mocking service sends the
response message that is defined for the 201 status code. With the MS2-Status-Code-Selection header,
you can change this default behavior or the mocking service.
You can combine the use of MS2-Status-Code-Selection with the use of MS2-Error-Level. The mocking
service sorts in ascending numeric order the status codes that are in the range of error status
codes specified by MS2-Error-Level, and then returns an error status code from that range, according
to the strategy specified by MS2-Status-Code-Selection.
The possible values of MS2-Status-Code-Selection are:
`FIRST`
The mocking service sorts the list of status codes in ascending numeric order and returns the lowest
status code. For example, if the specification defines the status codes for a POST method in the
order 500, 409, 400, 200, the mocking service returns the response for the 200 status code.
`RANDOM`
The mocking service randomly selects one of the status codes to return. For example, if the
specification defines the status codes for a POST method 500, 409, 400, 200, the mocking service
returns the response for any one of them.
## MS2-Strict-Model-Validation
This header can be helpful when you are simulating calls to an API with a specification that was
written before API Designer switched to its stricter parser on January 10, 2019.
When you set this header to `false`, you can use the mocking service even when the API specification
contains errors.
When you set this header to `true`, the mocking service validates the specification before
responding. If there is an error in the specification, the mocking service fails with that error.
Otherwise, the mocking service works as usual.
## See Also
- [Simulate Calls to an API](https://docs.mulesoft.com/design-center/design-mocking-service)
---
product: Design Center
---
# Adding Dependencies to an API-Specification Project
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
In projects for API specifications or API fragments, you can add dependencies of either RAML
fragments, OAS components, JSON schemas, or rulesets. Because the dependencies are referenced in
Anypoint Exchange, you cannot directly edit them in your projects.
If you export your project or someone downloads your project as RAML from Exchange, the resulting
ZIP file contains the referenced dependencies.
> [!CAUTION] You must not edit the referenced dependencies in an editor other than the API Designer
> editor. If you export your project to work on it in another editor, edit the referenced
> dependencies, and then try to import the project back into the text editor, the import fails.
> Studio does not support OAS 3.0 fragments.
## Add Dependencies to an API-Specification Project
> [!NOTE] You can add up to **100 dependencies** (Fragments and Rulesets) per project.
To add dependencies to an API-specification project:
1. In the text editor navigation menu, click the **Exchange dependencies** icon
().
2. Click the add icon (+) for the dependency type that you want to add.
3. To filter the list of dependencies you can:
- Select an organization
- Search by keyword
- Select **Include versions in Development**
4. Select the dependency versions you want to add:
- To use a version of a dependency other than latest, select the version for that dependency in
the **Version** drop-down.
- To view only the dependencies you’ve selected, click **Show selected only**.
- You can see the format of the fragment (RAML, OAS, or JSON schema) next to each fragment’s
name.
5. Click **Add dependency**.
> [!NOTE] API Designer supports a maximum of 1,000 files for dependencies, with a total file size no
> greater than 300 MB.
## View Dependency Contents
To view the contents of a dependency, click the more options menu icon
() for that dependency
and then select **Show in Files** or **Open in Exchange**.
> [!NOTE] If you select **Show in Files**, the **Files** section expands and the dependencies are
> shown in the `exchange_modules` section. The subsections correspond to the URI for the referenced
> dependency, which is its asset identifier, or GAV (group ID, asset ID, and version), in Exchange.
When you are ready to continue work on your API project, click **Files** > API project file name.
## Ruleset Dependencies
If your API has been identified as governed through centralized API governance, a dot or warning
icon appears on the **Exchange dependencies** icon to indicate you need to take action on the
dependencies for this project. Click the **Exchange dependencies** icon to view and follow the
interactive instructions to add rulesets as dependencies to your project.
Even if your projects have not been identified as requiring action, you can proactively check the
conformance of your APIs by adding published rulesets as dependencies to your API project.
If your API fails to conform to the rulesets that your organization validates against, you get an
email notification. You can click **Code in Design Center** to open API Designer, or click **API
Details in Exchange** to be redirected to the API asset Conformance Status page.
1. If the asset version has an editable branch in API Designer, a pop-up appears where you can see
the missing rulesets filtered by tags, category, and lifecycle state. To edit those filters,
click **Edit criteria**. When you are done, click **Add all rulesets**.
_Result_: The rulesets are added to your project.
2. If the asset version doesn’t have an editable branch in API designer, you can either select an
editable branch of your project or create a new branch from your current version. You can then
add the missing rulesets to that editable branch. When you have your branch, a pop-up appears
where you can see the missing ruleset filtered by tags, category, and lifecycle state. To edit
those filters, click **Edit criteria**. When you are done, click **Add all rulesets**.
_Result_: The rulesets are added to your project.
## Improving Ruleset Validation
When you add rulesets as dependencies, the rulesets are automatically validated by default. The
complexity of the API and rulesets might increase the number of diagnostics being computed and
trigger multiple automatic validations.
The validation takes more time if:
- Your API is modularized, has complex recursive types, or has circular references.
- You add multiple ruleset dependencies to an API project.
- You are consuming a significant amount of browser resources.
To improve ruleset validation times:
- Close unnecessary browser tabs or applications.
- Ensure your device is running efficiently and has enough memory and CPU resources.
- Switch to manual validation. This runs a single validation for each ruleset rather than triggering
multiple automatic validations that might exhaust your available resources.
If the validation process takes too long, a warning message appears informing you that
auto-validation is disabled for that project.
- To change to manual mode, click **Ok**.
- To continue using auto-validation, click **Cancel**. Note that if the auto-validation of rulesets
still takes too long, you get the warning message again.
You can switch between auto-validation and manual validation in your API project. This changes the
validation setting for that specification only.
To turn on manual validation of your rulesets:
1. In the **Project Errors** section of the text editor, select the **Governance** tab.
2. Click the **Governance auto-validation** icon
()
to disable auto-validation.
3. Click the **Validate for governance** icon
() to
enable manual validation.
This runs a single validation for each ruleset rather than triggering multiple automatic
validations that might exhaust your available resources.
To enable auto-validation again:
1. In the **Project Errors** section of the text editor, select the **Governance** tab.
2. Click the auto-validation icon
()
to enable auto-validation again.
> [!NOTE] If the auto-validation still takes too long, you get the warning message again.
## Fix Governance Conformance Issues
After you add the rulesets as dependencies, you can view the conformance messages in the **Project
Errors** section of the text editor. Use the provided information to fix any conformance issues and
then republish your API specification.
## See Also
- [Finding API Conformance Issues in API Specifications](https://docs.mulesoft.com/api-governance/find-conformance-issues)
- [Create an Asset](https://docs.mulesoft.com/exchange/to-create-an-asset)
---
product: Design Center
---
# API Designer Troubleshooting
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
This page describes common issues that sometimes occur when working in API Designer, along with
their causes and recommended troubleshooting steps.
## Preparing to publish status persists
While working in API Designer, these issues sometimes occur:
- The **Preparing to publish** dialog doesn’t complete when publishing to Exchange.
- API specifications don’t display validation errors, warnings, or suggestions.
- The API Console doesn’t render or remains blank.
- The browser console shows a `NetworkError` related to loading the `anypoint-als.js` library.
These issues typically occur when a required API Designer component fails to load due to network
restrictions.
API Designer relies on API Language Services, which is a background service, to enable validation
and rendering. In some environments, corporate firewalls, VPNs, or proxies can block or interrupt
the download of this component, preventing the editor from functioning correctly.
### Verification and diagnostics
To verify whether your network is correctly delivering the required resources:
- **Compare file delivery via cURL** Run this command and confirm the response is successful and
that the file size is approximately 1.5 MB:
```bash
curl -I https://cdn.anypoint.mulesoft.com/artifacts/api-designer-ui/app/static/js/anypoint-als.01bd90ee2cb9622ee518fcb3e30c444e.js
```
#### Troubleshooting
To identify and resolve the issue:
- **Test outside restricted networks**: Try accessing API Designer without a corporate VPN or proxy.
- **Use a clean browser session**: Clear your browser’s cache and cookies, then reload the page.
Alternatively, open a private or incognito window and disable browser extensions.
- **Try a different browser**: Switch to another browser, such as Chrome, Edge, Firefox, or Safari.
- **Check local security software**: Ensure antivirus or endpoint protection tools aren’t blocking
background scripts or service workers.
## See Also
- [Known Issues](https://help.salesforce.com/s/issues)
---
product: Design Center
---
# API Specification for MuleSoft Connectivity Ecosystem
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
If you are an independent software vendor (ISV), you can participate in the MuleSoft Connectivity
Ecosystem by auto-generating a connector from a REST API specification. These steps explain how to
prepare your API specification in Anypoint Platform and how to work with your MuleSoft BD
counterpart to do the rest.
1. In Anypoint Platform, follow these steps to prepare your API specification:
1. Sign up for Anypoint Platform:
[https://anypoint.mulesoft.com/login/#/signup](https://anypoint.mulesoft.com/login/#/signup)
2. Log into Anypoint Platform and click **Design Center**.
3. Create a new API specification project by clicking **Create new** in the top-right corner
and then clicking **New API Specification**.
4. In the **New API Specification** window, specify the name of the project, select **I’m
comfortable designing it on my own**, and select the language of the specification. Then,
click **Create API**.
5. Delete the file that is automatically generated by hovering over its name, clicking the
three dots to its right, and selecting **Delete**.
6. On the left side of the screen, click the action menu (the three-dot icon) at the top of the
file list and select **Import**. You can import a RAML or `.oas` file, a `.zip` file, or a
specification that is at a URL.
7. After importing, test your API to make sure it works as you expect it to.
1. In the top-right corner of the screen, switch on the mocking service.
2. In the file list, select your API specification.
3. In the API summary on the right side of the screen, expand the **Resources** entry until
you see the methods for your resources.
4. Click one of the methods.
5. Review the information about the method.
6. Click **Try It**.
7. If the endpoint requires parameters, specify values for them.
8. Click **Send**.
The results of the test of the method appear on the right side of the screen under the **Send**
button.
2. After your API specification is ready, save it in a git-compatible repository, such as GitHub or
Bitbucket.
3. Contact your MuleSoft BD counterpart and follow these steps:
1. Sign the Technology Partner Agreement (provided by your MuleSoft BD counterpart)
2. Ask for an extension to the expiration date of your trial of Anypoint Platform.
3. Ask for an invitation to the Connectivity Assets Manager tool, a self-service certification
tool for connectivity assets, and create a new Anypoint Platform account based on the
invitation.
4. Schedule a short demonstration to help MuleSoft understand your APIs and how they work in
Anypoint Platform.
---
product: Design Center
---
# AsyncAPI Specifications
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
You can create or import your AsyncAPI specifications in API Designer and then edit, document, and
publish them.
AsyncAPI is a language that describes messaging interfaces. This open-source, industry-standard
language is agnostic to any technology. To learn more, see the
[AsyncAPI documentation](https://www.asyncapi.com/docs/tutorials/getting-started).
AsyncAPI makes it easy to work with event-driven architecture by separating the API into three
layers:
- Events: Message or data to be shared with other services
- Channels: Destination of the message to be sent or received
- Transport: Technology that transports the message, such as RabbitMQ, Kafka, or Anypoint MQ
You can create or import an API specification in API Designer.
## Create an AsyncAPI Specification in API Designer
To create an AsyncAPI specification in API Designer:
1. In Design Center, click **Create New**.
2. Select **New AsyncAPI**.
3. In the **New AsyncAPI** dialog, name your project.
4. Select the AsyncAPI language under **Specification Language**.
The text editor opens.
For more information about how to use API Designer, refer to
[Create an API Specification with the Text Editor](https://docs.mulesoft.com/design-center/design-create-publish-api-raml-editor).
## Import AsyncAPI Specifications
To import AsyncAPI specifications from Anypoint Exchange or from your filesystem:
1. Click the gear icon at the top right of the text editor.
2. Select from the following options:
- Select **Import from Exchange** to see the following lists:
- API specifications that are available from the business organization that your user ID
belongs to in Anypoint Platform
- API specifications that are published by MuleSoft
- Select **Import** to import an API specification from your local filesystem.
3. As appropriate, continue to work with your AsyncAPI specification in API Designer:
- Develop and edit AsyncAPI specifications.
- View documentation that is included in AsyncAPI specifications.
- Publish AsyncAPI specifications to Anypoint Exchange.
## Example AsyncAPI 2.6 Specification
Following is an example that you can copy into API Designer to get started with event-driven APIs.
The following API specification example defines a typical event-driven process that uses Anypoint MQ
and Kafka protocols. Sections in the example specification are:
- AsyncAPI
Identifies the API model as AsyncAPI and specifies the title and version of the API spec
- Servers Defines message brokers that determine the connectors to use (indirectly) when publishing
events or subscribing to events through operations in the AsyncAPI module:
- `AMQ-prod` configures an Anypoint MQ Broker
- `Kafka-prod` configures a locally hosted Kafka broker
- Operation Defines the action that the application takes and whether the event is consumed or
published
- Channels Defines the bindings:
- `order-placed`, `order-cancelled`, and `order-confirmed` configures Anypoint MQ channels for
publishing and subscribing to orders
- `order-backordered` configures a Kafka channel for publishing and subscribing to backorders
- Components
Defines the structure of messages for the different types of orders, which include `OrderPlaced`,
`OrderCancelled`, `OrderConfirmed`, and `BackOrder`
To try the example, create a new AsyncAPI specification in Design Center and copy the following code
directly into API Designer:
```yaml
asyncapi: "2.6.0"
info:
title: Async-AMQ-Kafka-Orders
version: "1.0.0"
description: Orders API
license:
name: Anypoint MQ
url: https://license.com
contact:
name: Max Muley
email: max@salesforce.com
url: http://www.salesforce.com
defaultContentType: application/json
tags:
- name: Orders API
description: API for orders
servers:
AMQ-prod:
url: https:://your_MQ_server_URL_here
protocol: anypointmq
protocolVersion: v1
description: Anypoint MQ broker
Kafka-prod:
url: localhost:9092
protocol: kafka
description: kafka broker
channels:
order-placed:
description: new orders channel
servers:
- AMQ-prod
publish:
operationId: listen-order-placed
description: listen for new order events
summary: Order Placed Event
message:
$ref: "#/components/messages/OrderPlaced"
subscribe:
operationId: publish-order-placed
description: publish new order events
summary: Order Placed Event
message:
$ref: "#/components/messages/OrderPlaced"
order-updated:
description: updated orders channel
servers:
- AMQ-prod
publish:
operationId: listen-order-updated
description: listen for updated order events
summary: Order updated Event
message:
$ref: "#/components/messages/OrderPlaced"
subscribe:
operationId: publish-order-updated
description: publish updated order events
summary: Order updated Event
message:
$ref: "#/components/messages/OrderPlaced"
order-cancelled:
description: orders cancelled channel
servers:
- AMQ-prod
publish:
operationId: listen-order-cancellations
description: listen for order cancellation events
summary: Order Cancelled Event
message:
$ref: "#/components/messages/OrderCancelled"
subscribe:
operationId: publish-order-cancellations
description: publish order cancellation events
summary: Order Cancelled Event
message:
$ref: "#/components/messages/OrderCancelled"
order-confirmed:
description: orders confirmed channel
servers:
- AMQ-prod
publish:
operationId: listen-order-confirmations
description: listen for order confirmation events
summary: Order Confirmed Event
message:
$ref: "#/components/messages/OrderConfirmed"
subscribe:
operationId: publish-order-confirmations
description: publish order confirmation events
summary: Order Confirmed Event
message:
$ref: "#/components/messages/OrderConfirmed"
order-backordered:
servers:
- Kafka-prod
description: orders backordered channel
publish:
operationId: listen-order-backordered
description: listen for backorder events
summary: Backorder Event
message:
$ref: "#/components/messages/BackOrder"
subscribe:
operationId: publish-order-backordered
description: publish backorder events
summary: Backorder Event
message:
$ref: "#/components/messages/BackOrder"
components:
messages:
OrderPlaced:
payload:
type: object
properties:
orderId:
type: string
customerName:
type: string
email:
type: string
items:
type: array
items:
type: object
properties:
productId:
type: string
productName:
type: string
quantity:
type: integer
price:
type: number
OrderConfirmed:
payload:
type: object
properties:
orderId:
type: string
email:
type: string
OrderCancelled:
payload:
type: object
properties:
orderId:
type: string
email:
type: string
reason:
type: string
BackOrder:
payload:
type: object
properties:
orderId:
type: string
email:
type: string
```
## Example AsyncAPI 2.6.0 Specification (Inline Avro)
If you created an AsyncAPI specification project, you can replace the initial API specification with
following example code to test inlining the API specification fragments:
```yaml
asyncapi: 2.6.0
info:
title: Example AsyncAPI Spec (Inline Avro)
version: "1.0.0"
channels:
myChannel:
publish:
message:
schemaFormat: "application/vnd.apache.avro;version=1.9.0"
payload:
name: AmericanFlightDataType
type: record
fields:
- name: ID
type: int
default: 1
- name: code
type: string
default: ER38sd
- name: price
type: int
default: 400
- name: departureDate
type: string
default: 2017/07/26
- name: origin
type: string
default: CLE
- name: destination
type: string
default: SFO
- name: emptySeats
type: int
default: 0
- name: plane
type:
name: Plane
type: record
fields:
- name: type
type: string
- name: totalSeats
type: int
```
## Example AsyncAPI Specification Fragment (Avro Schema)
If you created an Avro Schema fragment, you can replace the initial API fragment with following
example code:
```yaml
{
"name": "AmericanFlightDataType",
"type": "record",
"fields":
[
{ "name": "ID", "type": "int", "default": 1 },
{ "name": "code", "type": "string", "default": "ER38sd" },
{ "name": "price", "type": "int", "default": 400 },
{ "name": "departureDate", "type": "string", "default": "2017/07/26" },
{ "name": "origin", "type": "string", "default": "CLE" },
{ "name": "destination", "type": "string", "default": "SFO" },
{ "name": "emptySeats", "type": "int", "default": 0 },
{
"name": "plane",
"type":
{
"name": "Plane",
"type": "record",
"fields":
[{ "name": "type", "type": "string" }, { "name": "totalSeats", "type": "int" }],
},
},
],
}
```
## Example Referencing an Avro Fragment from an Async API
```yaml
asyncapi: 2.6.0
info:
title: Example AsyncAPI Spec (Inline Avro)
version: "1.0.0"
channels:
myChannel:
publish:
message:
schemaFormat: application/vnd.apache.avro;version=1.9.0
payload:
$ref: AmericanFlightDataType.avsc
```
> [!NOTE] For AVRO schema documents, `.avsc` is the default extension, but `.json` files are also
> supported.
## Example AsyncAPI 2.0 Specification
This example is a typical event-driven process that is documented for easy reuse. It has a service
with two channels, one that books the trade and another that gets the result of the booking
asynchronously.
Sections in the example specification are:
- AsyncAPI
Identifies the API model as AsyncAPI and specifies the title and version of the API spec.
- Channels
- The book\_trade channel enables you to specify the buy/sell order, symbol, and number of shares
you would like to purchase.
- The trade\_result channel returns the result of the transaction.
To try the example, create a new AsyncAPI specification in Design Center and copy the following code
directly into API Designer:
```yaml
asyncapi: 2.0.0
info:
title: Async Request/Trade API
version: 0.1.0
channels:
book_trade:
publish:
message:
payload:
type: object
properties:
trade-id:
type: integer
minimum: 0
description: the order id of the message coming
trade-symbol:
type: string
minimum: 0
Description: ticker symbol of the stock.
trade-type:
type: string
format: string
description: BUY or SELL
trade-amount:
type: number
format: float
description: the number of shares to be traded.
trade_result:
subscribe:
message:
payload:
type: object
properties:
trade-id:
type: integer
minimum: 0
description: the order id of the message coming
trade-symbol:
type: string
format: string
description: ticker symbol of the stock.
trade-time:
format: date-time
description: date and time of the order.
trade-amount:
type: number
format: float
description: the number of shares to be traded.
trade-type:
type: string
format: string
description: BUY or SELL
trade-status:
type: string
format: string
description: PENDING, PROCESSED and FAILED
```
For documentation on using API Designer to work with your specification, see
[API Designer](https://docs.mulesoft.com/design-center/design-create-publish-api-specs).
## See Also
- [Design APIs in API Designer](https://docs.mulesoft.com/design-center/design-create-publish-api-specs)
- [Configure API Instances in Exchange](https://docs.mulesoft.com/exchange/to-configure-api-settings)
- [AsyncAPI](https://www.asyncapi.com/docs/tutorials/getting-started)
---
product: Design Center
---
# Best Practices when using API Designer
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
When you perform tasks on Design Center, you might encounter issues. Use the following topics to
help you resolve them.
## API Designer Best Practices
- Divide your fragments into short, reusable dependencies when possible.
- Keep only one version of the same dependency.
- Keep only one browser tab open at a time.
### API Designer Resources
When using API Designer, the required resources to parse the specification depend on the users own
resources. For API Designer to function properly, ensure your computer has the following minimum
resources available when using API Designer:
- 8 GB RAM
- Ryzen series 5 / Intel i5 CPU or higher
To achieve optimal parser performance, keep the total project size for all files in your design
project below 500 KB.
A project size that exceeds 1.5 MB severely affects validation time.
### OAS Specification Best Practices
- Use the `$ref` property to define reusable components. To improve parsing efficiency, reference
each component from the API specification instead of duplicating component definitions, for
example:
components: schemas: User: type: object properties: id: type: integer
paths: /users: get: responses: '200': description: Successful response content: application/json:
schema: $ref: '#/components/schemas/User'
- Use simpler types to represent your data if possible. Avoid unnecessary nesting and complicated
types, for example:
properties: age: type: integer # Prefer simple types over complex types like objects
- Use the `enum` property for fields with a fixed set of values to improve parsing efficiency:
properties: status: type: string enum: \[active, inactive\]
- Use simple nesting for objects to simplify the structure and improve readability and parsing
efficiency:
\# Good properties: name: type: string address: type: string
# Avoid
properties: user: type: object properties: profile: type: object properties: name: type: string
- Use `response` headers instead of the response body to provide additional information, for
example:
responses: '200': description: Successful response headers: X-Rate-Limit-Limit: description: The
number of requests allowed in the current period schema: type: integer
- Provide concise and short examples:
Book: type: string example: "Explain the string with as few words as possible."
- When using union-type properties, use `oneOf` to represent union-type object fields, `allOf` to
represent an intersection type and composite objects and fields, and `anyOf` when defining a
property with multiple possible data structures.
### RAML Specification Best Practices
- When extracting RAML fragments, import each fragment as a local declaration first:
Create a fragment file, and before publishing the fragment to Anypoint Exchange, import the local
fragment file to validate that the fragment works as expected. If the fragment works, publish the
fragment to Exchange so you can reuse the fragment in your API specifications instead of
duplicating it.
- Reuse data types as declarations.
- Use inheritance only when needed:
Car: description: This is a car properties: brand: string model: string example: brand: Toyota
model: Corolla Person: properties: owns: Car
- Use short unions:
Person: type: Employee | Customer
- Use simple traits, and avoid combining traits with resource type properties:
/basic: type: {resourceTypes.fhirResourceType: { postExample : !include
/examples/requests/post\_resource.json, getExample : !include
/examples/responses/get\_resource.json, bundleName : basic.BasicBundle } } /\_search: get: is: \[
searchParams \] post: is: \[ POSTSearchParams \]
---
product: Design Center
---
# Common Problems Found in RAML 0.8 API Specifications
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
The following sections describe common errors authors make when writing API specifications in RAML
0.8, and tips for resolving them.
## Using a reserved name for a schema
If you use a reserved name as the name of a schema, the editor displays this message:
‘schemaName’ cannot be used to name a custom schema
Examples of reserved names are `string`, `integer`, `number`, and `object`. Any name that is used in
the RAML specification cannot be used as the name for a schema.
For example, this API specification would cause the editor to display the message:
#%RAML 0.8
title: Example API Spec
schemas: string: type: string
To resolve the problem, you would need to use a different name in the schema declaration:
#%RAML 0.8
title: Example API Spec
schemas: customString: type: string
[Back to the top](#bookmark-a)
## Problems when validating examples
### Not using a data type of string for the example of a Boolean enum
Whether the values for a Boolean enum are both strings or Boolean values, the example of the enum
must be a string. To illustrate the violation, this API specification shows an example using the
wrong data type.
#%RAML 0.8 title: ExampleRAML /nob: head: responses: 204: headers: X-NOB-Exists: enum: \[true,
false\] example: true
RAML 0.8 supports enum values as strings only, not as boolean values. Also, in the example RAML
above, no data type for the enum is declared. In RAML 0.8, when a data type is not declared, it is
assumed to be `string`.
Therefore, the values in the enum in the incorrect example above must be in quotation marks. That’s
because the data type of an example must be the same as the data type of the element that it is an
example of.
The last two line of the example RAML above should then be as they are in this correction:
... enum: \["true", "false"\] example: "true"
[Back to the top](#bookmark-a)
### Not using a required property in the example of a schema that defines that property
If a schema defines a required property, the example of that schema must use that property. In this
example of the problem, the following API specification defines a response for the endpoint
`/order/{id}`. The definition includes two files: `get_order_response_schema.json` and
`get_order_response.json`.
#%RAML 0.8 title: ExampleRAML version: 1.0 ... /order: displayName: Orders API /create: ...
/{id}: displayName: Get Order by OrderId description: This operation will get an order by order ID
from Salesforce. get: description: This operation returns the order from Salesforce by Fulfillment
Order ID, not by the Salesforce unique ID. responses: 200: body: application/json: schema: !include
get\_order\_response\_schema.json example: !include get\_order\_response.json
The file `get_order_response_schema.json` defines the property `sfOrderId` as a required property.
{ "type":"object", "$schema": "http://json-schema.org/draft-03/schema", "id":
"http://com.mulesoft.demo.orders.get.json.order", "required":false, "properties":{ ... "sfOrderId":
{ "type":"string", "id": "http://com.mulesoft.demo.orders.create.json.get.sfOrderId",
"required":true }, ...
The example of the schema is in `get_order_response.json`. However, the name of the required
property is misspelled as `sOrderId`.
{ "orderId": 14523, "sOrderId": "fadfead3524523", "sfAccountId": "fedfes3653635", "orderName":
"Order From Manufacturing-Company, Inc.", "total": 174.92, "orderType": "E-Commerce Order",
"description": "8 widgets", "orderDate": "04-03-2018" }
[Back to the top](#bookmark-a)
### Not using in an example of a schema the data type that the schema defines
For example, the schema in the following API specification defines the data type for the property
`title` as an object; however, an array is used in the example of the schema.
#%RAML 0.8 title: ExampleRAML schemas:
- presentation: | { "$schema": "http://json-schema.org/draft-03/schema", "type": "object",
"properties": { "title": { "type": "string" } } }
/presentations: &presentations type: { typedCollection: { schema: presentation } } get: responses:
200: body: application/json: example: | \[ { "title": "Presentation Video" }, { "title":
"Environment Spec Report" } \]
[Back to the top](#bookmark-a)
### Using 0 or 1 as the value of an example of a Boolean
An example for a Boolean must have a value of "true" or "false". In this API specification
illustrating the violation, the value of the example for the form parameter `is_public` is
incorrect.
#%RAML 0.8 title: ExampleRAML
/upload: post: description: | Upload a photo body: multipart/form-data: formParameters: title:
description: The title of the photo. is\_public: type: boolean example: 1
### Not including a property in an example
If an example is missing a property of the type that it is exemplifying, the editor displays this
violation message:
should have required property 'property name'
For example, the property `age` is missing in the example:
#%RAML 0.8 title: Example API Spec
/clients: get: responses: 200: body: application/json: schema: | { "$schema":
"http://json-schema.org/draft-03/schema", "properties": { "firstName": { "type": "string" },
"lastName": { "type": "string" }, "age": { "type": "number", "required": true } }, "required":
false, "type": "object" } example: firstName: John lastName: Smith
Either add the property to the example or, in the type declaration, declare the property as
optional.
In this case, the property is added to the example:
#%RAML 0.8 title: Example API Spec
/clients: get: responses: 200: body: application/json: schema: | { "$schema":
"http://json-schema.org/draft-03/schema", "properties": { "firstName": { "type": "string" },
"lastName": { "type": "string" }, "age": { "type": "number", "required": true } }, "required":
false, "type": "object" } example: firstName: John lastName: Smith age: 30
In this case, the property is declared as optional:
#%RAML 0.8 title: Example API Spec
/clients: get: responses: 200: body: application/json: schema: | { "$schema":
"http://json-schema.org/draft-03/schema", "properties": { "firstName": { "type": "string" },
"lastName": { "type": "string" }, "age": { "type": "number", "required": false } }, "required":
false, "type": "object" } example: firstName: John lastName: Smith
[Back to the top](#bookmark-a)
[Back to the top](#bookmark-a)
## Not providing a value for the `title` node
The `title` node cannot lack a value, as it does here:
#%RAML 0.8 title:
[Back to the top](#bookmark-a)
## Not using the data type of the RAML element in the example for that element
In all cases, the data type of an example must match the data type of the element that it is an
example of.
In this incorrect API specification, a query parameter is defined as a string; however, the example
of the query parameter is an integer.
#%RAML 0.8 title: ExampleRAML /books: get: queryParameters: publicationYear: type: string example:
2016
[Back to the top](#bookmark-a)
## Using an invalid path for a reference inside a JSON schema
When you use the `$ref` keyword in a JSON schema, the path that you specify with it must start at
the root of the schema. For example, the `$ref` keyword used for the property `input2` in the
following schema uses an incorrect path to refer to the property `input`.
#%RAML 0.8 title: ExampleRAML version: v1 schemas:
- authCodeResponse : | {
"$schema": "http://json-schema.org/draft-04/schema",
"properties": {
"input": {
"type": "string"
},
"input2": {
"$ref":
"input" } }, "type": "object" }
The path must start at the root level of the schema and descend through the tree structure. This
example of the schema shows the same `$ref` keyword using the correct path.
{
"$schema": "http://json-schema.org/draft-04/schema",
"properties": {
"input": {
"type": "string"
},
"input2": {
"$ref":
"#/properties/input" } }, "type": "object" }
[Back to the top](#bookmark-a)
## Declaring a URI parameter that is never used
If an API specification declares a URI parameter, but then does not use that parameter, the editor
displays this warning message:
unused uri parameter “parameter”
If the parameter is declared as a base URI parameter, but is not used, then this is the warning
message:
unused base uri parameter “parameter”
For example, the following API specification would generate two warning messages:
unused uri parameter "unusedParam"
unused base uri parameter "unusedUriParam"
#%RAML 0.8 title: test
baseUri: http://param.raml/a/{baseUriParam1}/{nonExists}/{baseUriParam2}
baseUriParameters: baseUriParam1: type: string baseUriParam2: type: string unusedParam: type: string
/endpoint/{uriParam1}/{nonExistsUri}: uriParameters: uriParam1: type: string unusedUriParam: type:
string
To resolve the warning messages, you would simply need to remove the lines that declare these
parameters:
#%RAML 0.8 title: test
baseUri: http://param.raml/a/{baseUriParam1}/{nonExists}/{baseUriParam2}
baseUriParameters: baseUriParam1: type: string baseUriParam2: type: string
/endpoint/{uriParam1}/{nonExistsUri}: uriParameters: uriParam1: type: string
[Back to the top](#bookmark-a)
## Not declaring a media type for a payload
If the declaration of a payload does not declare a media type, the editor displays this message:
Payload media type is mandatory
For example, the editor would display this message for the following API specification:
#%RAML 0.8 title: Example API Spec /media: get: responses: 200: body: type: string
There are two methods that you can choose from to resolve the problem:
- Declare the media type locally in the payload declaration.
#%RAML 0.8 title: Example API Spec /media: get: responses: 200: body: application/json: type:
string
- Specify the default media type globally for the API specification.
#%RAML 0.8 title: Example API Spec
mediaType: application/json
/media: get: responses: 200: body: type: string
The following example uses both a global and a local declaration. In this case, the `mediaType` node
defines acceptable media types as `application/json` and `application/xml`. The first type,
`Person`, returns a body that is in either media type. However, the second type, `Another`,
overrides the global declaration with a local one, and returns only a JSON body.
#%RAML 0.8 title: New API mediaType: \[ application/json, application/xml \] schemas: Person:
Another: /list: get: responses: 200: body: Person /send: post: body: application/json: schema:
Another
[Back to the top](#bookmark-a)
## Not referencing fragments by using the `!include` tag
If an API specification uses the key `uses` to reference fragments, the editor displays this
message:
Fragments must be imported by using '!include'
[Back to the top](#bookmark-a)
## Not applying libraries by using the `uses` key
If an API specification uses the `!include` tag to apply a library, the editor displays this
message:
Libraries must be applied by using 'uses'
[Back to the top](#bookmark-a)
## Problems with syntax
### Including a schema that contains invalid JSON
The JSON in files that are included in the value of the `schemas` property must be valid.
The first example includes the schema `appSwitcher.json`. However, the second shows that there is an
error in the JSON: at the end of the last value, there is a comma, though there should instead be a
quotation mark.
#%RAML 0.8 title: ExampleRAML schemas:
- appSwitcher: !include schemas/appSwitcher.json
{ "appMenuItems" : \[ { "type" : "Tabset" , "content" : null , "icons" : null , "colors" : null ,
"label" : "Call Center" , "url" : "/home/home.jsp?tsid=02uxx00000056Sr" } , { "type" : "Tabset" ,
"content" : null , "icons" : null , "colors" : null , "label" : "Community" , "url" :
"/home/home.jsp?tsid=02uxx00000056Sw" } , { "type" : "Tabset" , "content" : null , "icons" : null ,
"colors" : null , "label" : "App Launcher" , "url" :
"/app/mgmt/applauncher/appLauncher.apexp?tsid=02uxx00000056Sx, } \] }
[Back to the top](#bookmark-a)
### Using invalid JSON in examples of JSON schemas
Examples of JSON schemas must be valid, unlike the example in the following API specification:
#%RAML 0.8 title: ExampleRAML ... /api: get: responses: 200: body: application/json: schema: {
"type": "object", "required": true, "$schema": "http://json-schema.org/draft-03/schema",
"properties": { "a": { "type": "boolean", "required": true } } } example: { "a: { "a": "" }
[Back to the top](#bookmark-a)
### Not providing a YAML map when a facet requires one
When a facet is described in the RAML 0.8 specification as requiring a map as a value, but the API
specification doesn’t provide a map, the editor returns the message `YAML map expected`.
Here is an example of the error:
#%RAML 0.8 title: Test version: 1.0 securitySchemes: basic: type: Basic Authentication settings:
There are two ways to fix the error.
- Provide a map as a value.
#%RAML 0.8 title: Test version: 1.0 securitySchemes: basic: type: Basic Authentication settings:
requestTokenUri: https://api.mysampleapi.com/1/oauth/request\_token
- Delete the facet — in this case, `settings` — that requires a map.
#%RAML 0.8 title: Test version: 1.0 securitySchemes: basic: type: Basic Authentication
[Back to the top](#bookmark-a)
## Using an unsupported property
This error occurs if you use an undefined facet.
Example error message
`Property invalidfacet not supported in a RAML 0.8 webApi node`, where `invalidfacet` is the name of
a facet that is not defined in the RAML specification.
Here is an example that would generate this error:
Table 1. Incorrect Example vs. Corrected Example | Incorrect | Correct |
|---|
#%RAML 0.8
title: Test
invalidfacet:
version: | #%RAML 0.8
title: Test
version: |
[Back to the top](#bookmark-a)
## Declaring an undefined type in a header
This error occurs when a non-existent type is specified in a header.
Error message
`Cannot declare unresolved parameter`
In the incorrect example below, the value for the header `myHeader` has a typo. It is specified as
`strang`, not as `string`.
Table 2. Incorrect Example vs. Corrected Example | Incorrect | Correct |
|---|
#%RAML 0.8
title: test
/endpoint: post: headers: myHeader:
strang | #%RAML 0.8 title: test
/endpoint: post: headers: myHeader: string |
[Back to the top](#bookmark-a)
---
product: Design Center
---
# Common Problems Found in RAML 1.0 API Specifications
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
The following sections describe common errors authors make when writing API specifications in RAML
1.0, and tips for resolving them.
## Using the `schema` or `schemas` keyword instead of `type` or `types`
The specification for RAML 1.0 replaced the keywords `schema` and `schemas` with `type` and `types`.
If you use `schema` or `schemas`, the editor displays one of these warning messages:
‘schema' keyword it's deprecated for 1.0 version, should use 'type' instead
'schemas' keyword it's deprecated for 1.0 version, should use 'types' instead
For example, the following API specification generates both warning messages:
#%RAML 1.0 title: Incorrect API with schema and schemas
schemas: User: type: object properties: firstname: string lastname: string age: number
/users/{id}: get: responses: 200: body: application/json: schema: User
To resolve the problem, you would replace `schema` and `schemas` with `type` and `types`:
#%RAML 1.0 title: Correct API with type and types
types: User: type: object properties: firstname: string lastname: string age: number
/users/{id}: get: responses: 200: body: application/json: type: User
[Back to the top](#bookmark-a)
## Using a reserved name for a type
If you use a reserved name as the name of a type, the editor displays this message:
‘typeName’ cannot be used to name a custom type
Examples of reserved names are `string`, `object`, `integer`, `number`, and `object`. Any name that
is used in the RAML specification cannot be used as the name for a type.
For example, this API specification would cause the editor to display the message:
#%RAML 1.0
title: Example API Spec
types: string: type: string
To resolve the problem, you would need to use a different name in the type declaration:
#%RAML 1.0
title: Example API Spec
types: customString: type: string
[Back to the top](#bookmark-a)
## Common misconceptions about examples and RAML NamedExample fragments
To avoid common problems with referencing a named example with an `!include` tag, follow these two
guidelines:
- In your API specification, use the `examples` facet and only one `!include` tag, as in this
example:
#%RAML 1.0 title: test types: A: properties: a: string b: integer examples: !include fragment.raml
- In the fragment, ensure that each example consists of a name and values for each property, as in
the fragment below:
fragment.raml
#%RAML 1.0 NamedExample myExample1: a: "b1" b: 1
myExample2: a: "b2" b: 2
For a more detailed discussion of how to use named examples, see
[Guide to Defining Examples in RAML 1.0](https://docs.mulesoft.com/design-center/design-named-examples).
[Back to the top](#bookmark-a)
## Appending references with hash symbols to filenames in `!include` statements
A filename cannot be followed by a hash symbol and a reference to a location within the named file.
In this example, `IncrementType.raml#increment` is not a valid link.
#%RAML 1.0 DataType
type: object properties: startValue: integer endValue: integer exclusiveEndValue: boolean range:
type: array items: !include IncrementType.raml#increment
If your specification contains an violation of this type, but you meant to write a comment, place an
empty space before the "#" symbol. If you meant to reference an element that is in the file, such
references are not allowed. References to inner elements are valid only for XSD and JSON schemas.
[Back to the top](#bookmark-a)
## Not correctly using curly braces and brackets in JSON examples
There are many ways to misuse curly braces and brackets. This example illustrates one of them. An
array of groups of JSON key/value pairs is improperly enclosed in a pair of curly braces.
#%RAML 1.0 title: ExampleRAML ... /rooms: displayName: rooms get: description: get all rooms
responses: 200: body: application/json: example: | { \[{ "Name": "Superior King", "Number": "201",
"Property": "SE030", "Status": "Clean" }, { "Name": "Junior Suite", "Number": "202", "Property":
"NO131", "Status": "Clean" }\] }
If the example was meant be an object, then a key must be specified for it.
#%RAML 1.0 title: ExampleRAML ... /rooms: displayName: rooms get: description: get all rooms
responses: 200: body: application/json: example: { "some\_key": \[ { "Name": "Superior King",
"Number": "201", "Property": "SE030", "Status": "Clean" }, { "Name": "Junior Suite", "Number":
"202", "Property": "NO131", "Status": "Clean" } \] }
If the example was meant be an array, then the outside curly braces must be removed.
#%RAML 1.0 title: ExampleRAML ... /rooms: displayName: rooms get: description: get all rooms
responses: 200: body: application/json: example: \[ { "Name": "Superior King", "Number": "201",
"Property": "SE030", "Status": "Clean" }, { "Name": "Junior Suite", "Number": "202", "Property":
"NO131", "Status": "Clean" } \]
[Back to the top](#bookmark-a)
## Referencing libraries by using the `type` key
As explained in the RAML 1.0 specification, you must apply libraries with the `uses` node:
> Any number of libraries can be applied by using the OPTIONAL `uses` node ONLY at the root of a
> \["main"\] RAML or RAML fragment file. The value of the \`use\`s node is a map of key-value pairs.
> The keys are treated as library names, or namespaces, and the value MUST be the location of a RAML
> library file, usually an external RAML library fragment document.
If you apply a library with a `type` node, the editor displays this message:
Libraries must be applied by using 'uses'
Therefore, the following example is incorrect, given that the file `financeDetail.raml` is a
library.
#%RAML 1.0 title: ExampleRAML ... /claims: /{claim-id}: patch: body: application/json: type:
!include financeDetail.raml
This next example is correct.
#%RAML 1.0 title: ExampleRAML uses: lib: financeDetail.raml /claims: /{claim-id}: patch: body:
application/json: type: lib.myType
[Back to the top](#bookmark-a)
## Problems when validating examples
### Not including a property in an example
If an example is missing a property of the type that it is exemplifying, the editor displays this
violation message:
should have required property 'property name'
For example, the property `age` is missing in the example:
#%RAML 1.0 title: Example API Spec
types: User: type: object properties: firstName: string lastName: string age: integer example:
firstName: John lastName: Smith
Either add the property to the example or, in the type declaration, declare the property as
optional.
In this case, the property is added to the example:
#%RAML 1.0 title: Example API Spec
types: User: type: object properties: firstName: string lastName: string age: integer example:
firstName: John lastName: Smith age: 49
In this case, the property is declared as optional:
#%RAML 1.0 title: Example API Spec
types: User: type: object properties: firstName: string lastName: string age?: integer example:
firstName: John lastName: Smith
[Back to the top](#bookmark-a)
### Specifying values for an enum that does not match the enum’s data type
Because of the editor’s strict parsing according to the YAML specification, it does not
automatically cast values to declared data types. To illustrate the violation, here is an invalid
declaration of an enum:
type: string enum: \[1,2,3\]
The data type for the enum is `string`; however, the values are all integers. Because the editor
stricly parses according to the YAML specification, it does not cast the integers to `string` values
automatically. Therefore, either the type is declared incorrectly in this example and should be
`integer`, or the enum values need to be in quotation marks.
Here is another invalid declaration:
type: string enum: \[ "a", "b", "c", false, 3.0 \]
The value `false` is a `boolean`, while the value `3.0` is a `float`. Neither is converted to a
`string` value by the editor.
The next three declarations are valid.
type: string enum: \["1","2","3"\]
type: integer enum: \[1,2,3\]
type: string enum: \[ "a", "b", "c", "false", "3.0" \]
> [!NOTE] \=== This violation can occur not just in enums, but also anywhere an `integer`, `nil`
> value, or value of some other data type is introduced where the parser expects a `string` value.
> ===
[Back to the top](#bookmark-a)
### Using, in an example of a numeric type, an incorrect format for that type, if a format is specified
Examples of numeric types must conform to restrictions specified in the `format` node. In this
example of the violation, the format specified for the numeric type `collection` is int8. However,
the value of the example is greater than 127.
#%RAML 1.0 title: ExampleRAML types: collection: type: integer format: int8
/search: /code: get: body: application/json: type: collection example: 22342342
[Back to the top](#bookmark-a)
### Including undeclared properties in an example when additionalProperties is set to `false`
If an example for a type includes one or more properties that were not in the type declaration, the
editor displays this message:
should NOT have additional properties
The editor would display this message for the following API specification:
#%RAML 1.0 title: Example API Spec
types: User: type: object additionalProperties: false properties: firstName: string lastName: string
example: firstName: John lastName: Smith age: 49
There are three different methods that you can choose from to resolve the problem:
- Delete the extra property from the example
#%RAML 1.0 title: Example API Spec
types: User: type: object additionalProperties: false properties: firstName: string lastName:
string example: firstName: John lastName: Smith
- Add the property in the type declaration.
#%RAML 1.0 title: Example API Spec
types: User: type: object additionalProperties: false properties: firstName: string lastName:
string age: integer example: firstName: John lastName: Smith age: 49
- Change the value of `additionalProperties` to `true` or remove the line for `additionalProperties`
(because `additionalProperties` is `true` by default).
#%RAML 1.0 title: Example API Spec
types: User: type: object properties: firstName: string lastName: string additionalProperties:
true example: firstName: John lastName: Smith age: 49
[Back to the top](#bookmark-a)
### Types defined as `nil` in payloads are not valid
You cannot use a type in a payload if its data type is `nil`.
#### Example 1
In this example, the value of `type` must be `string`, not `nil`:
```none
#%RAML 1.0
title: test
types:
MyType:
type: nil
example: “test”
```
#### Example 2
In this example, the JSON schema must define `MyType` as a `string` type. However, the schema is
empty:
```none
#%RAML 1.0
title: test
types:
MyType:
type: !include schema.json # schema.json is an empty file
example: “test”
```
The error message in cases like this is `should be null at …`.
[Back to the top](#bookmark-a)
## Not providing a value for the `title` node
The `title` node cannot lack a value, as it does here:
#%RAML 1.0 title:
[Back to the top](#bookmark-a)
## Declaring a URI parameter that is never used
If an API specification declares a URI parameter, but then does not use that parameter, the editor
displays this warning message:
unused uri parameter “parameter”
If the parameter is declared as a base URI parameter, but is not used, then this is the warning
message:
unused base uri parameter “parameter”
For example, the following API specification would generate two warning messages:
unused uri parameter "unusedParam"
unused base uri parameter "unusedUriParam"
#%RAML 1.0 title: test
baseUri: http://param.raml/a/{baseUriParam1}/{nonExists}/{baseUriParam2}
baseUriParameters: baseUriParam1: type: string baseUriParam2: type: string unusedParam: type: string
/endpoint/{uriParam1}/{nonExistsUri}: uriParameters: uriParam1: type: string unusedUriParam: type:
string
To resolve the warning messages, you would simply need to remove the lines that declare these
parameters:
#%RAML 1.0 title: test
baseUri: http://param.raml/a/{baseUriParam1}/{nonExists}/{baseUriParam2}
baseUriParameters: baseUriParam1: type: string baseUriParam2: type: string
/endpoint/{uriParam1}/{nonExistsUri}: uriParameters: uriParam1: type: string
[Back to the top](#bookmark-a)
## Not declaring a media type for a payload
If the declaration of a payload does not declare a media type, the editor displays this message:
Payload media type is mandatory
For example, the editor would display this message for the following API specification:
#%RAML 1.0 title: Example API Spec /media: get: responses: 200: body: type: string
There are two methods that you can choose from to resolve the problem:
- Declare the media type locally in the payload declaration.
#%RAML 1.0 title: Example API Spec /media: get: responses: 200: body: application/json: type:
string
- Specify the default media type globally for the API specification.
#%RAML 1.0 title: Example API Spec
mediaType: application/json
/media: get: responses: 200: body: type: string
The following example uses both a global and a local declaration. In this case, the `mediaType` node
defines acceptable media types as `application/json` and `application/xml`. The first type,
`Person`, returns a body that is in either media type. However, the second type, `Another`,
overrides the global declaration with a local one, and returns only a JSON body.
#%RAML 1.0 title: New API mediaType: \[ application/json, application/xml \] types: Person: Another:
/list: get: responses: 200: body: Person\[\] /send: post: body: application/json: type: Another
[Back to the top](#bookmark-a)
## Not referencing fragments by using the `!include` tag
If an API specification uses the key `uses` to reference fragments, the editor displays this
message:
Fragments must be imported by using '!include'
[Back to the top](#bookmark-a)
## Not applying libraries by using the `uses` key
If an API specification uses the `!include` tag to apply a library, the editor displays this
message:
Libraries must be applied by using 'uses'
[Back to the top](#bookmark-a)
## Problems with syntax
### Including an example response that contains invalid JSON
When a JSON file is included as the example of a response message, the JSON in the file must be
valid. In this example of the violation, the example of the response for the 200 response code
contains an `!include` statement. The JSON in the included file incorrectly contains a comma after
the last key/value pair.
#%RAML 1.0 title: ExampleRAML ... /resume: description: "Gets candidate's resume." get:
queryParameters: ... headers: ... responses: 200: body: application/json: example: !include
exampleResumeData-200.json 500: ...
{ ... "assessments.characteristic.focusofattention.data"= "", }
[Back to the top](#bookmark-a)
### Not providing a YAML map when a facet requires one
When a facet is described in the RAML 1.0 specification as requiring a map as a value, but the API
specification doesn’t provide a map, the editor returns the message `YAML map expected`.
Here is an example of the error:
#%RAML 1.0 title: Test version: 1.0 securitySchemes: basic: type: Basic Authentication settings:
There are two ways to fix the error.
- Provide a map as a value.
#%RAML 1.0 title: Test version: 1.0 securitySchemes: basic: type: Basic Authentication settings:
requestTokenUri: https://api.mysampleapi.com/1/oauth/request\_token
- Delete the facet — in this case, `settings` — that requires a map.
#%RAML 1.0 title: Test version: 1.0 securitySchemes: basic: type: Basic Authentication
[Back to the top](#bookmark-a)
## Not defining a type that is used
When a type is used, but is not first defined, the editor returns the message
`Unresolved reference`.
In this example of the error, the type `mytype` is not defined.
#%RAML 1.0
title: test /path: post: responses: 200: body: application/json: type: mytype
To resolve the problem, define the type that you are using.
#%RAML 1.0
title: test types: mytype: string /path: post: responses: 200: body: application/json: type: mytype
[Back to the top](#bookmark-a)
## Using an unsupported property
This error occurs when a facet or data type is defined as having a specific set of properties, yet
an API specification defines the facet with a property that is not in that set. The error can also
occur if you use an undefined facet.
Example error message \* `Property minimum not supported in a RAML 1.0 stringScalarShape node`,
where `minimum` is the name of the unsupported property. A `string` does not have a minimum value.
\* `Property invalidfacet not supported in a RAML 0.8 webApi node`, where `invalidfacet` is the name
of a facet that is not defined in the RAML specification.
Here are examples that would generate these errors:
Table 1. Incorrect Examples vs. Corrected Examples | Incorrect | Correct |
|---|
#%RAML 1.0
title: Test
types:
top:
type: string
minimum: 1 | #%RAML 1.0
title: Test
types:
top:
type: string
minLength: 1 |
| Incorrect | Correct |
|---|
#%RAML 1.0
title: Test
invalidfacet:
version: | #%RAML 1.0
title: Test
version: |
| Incorrect | Correct |
|---|
#%RAML 1.0
title: Test
types:
Prop:
type: string
required: false
Obj: type: object properties: prop: type:
Prop | #%RAML 1.0 title: Test types: Prop: type:
string
Obj: type: object properties: prop: type: Prop required:
false |
[Back to the top](#bookmark-a)
## Invalid Type Inheritance
Two common occurrences that cause type-inheritance errors are incorrectly merging two types and
defining a weaker constraint in a subtype.
### Merging Two types incorrectly
This type of error occurs when you try to perform one of these actions:
- Merge a defined type with an undefined type
- Merge two undefined types
The error also occurs when you try to perform a merge with the wrong syntax.
Example error message
`Resolution error: Incompatible types [class amf.plugins.domain.shapes.models.ScalarShape, class amf.plugins.domain.shapes.models.NodeShape]`
The following example both tries to merge two undefined types and uses incorrect syntax for the
merge. The resolution of the error involves defining the types before the merge, and also using a
pipe for the merge syntax, not brackets and a comma.
Table 2. Incorrect Example vs. Corrected Example | Incorrect | Correct |
|---|
#%RAML 1.0
title: test
types:
Device:
type: [ Phone , Notebook ]
Phone: string
Notebook:
type: object
properties:
manufacturer:
type: string | #%RAML 1.0
title: test
types:
Phone: string
Notebook:
type: object
properties:
manufacturer:
type: string
Device:
type: Phone | Notebook |
[Back to the top](#bookmark-a)
### Defining a Weaker Constraint in a Subtype
A subtype that defines a weaker constraint than one defined by its parent type is invalid.
In this example, the subtype MyType2 has the optional property `name`, defined as a string, even
though the parent type MyType1 already defines its `name` property as required:
```none
#%RAML 1.0
title: test
types:
MyType1:
properties:
name: string
MyType2:
type: MyType1
properties:
name?: string #invalid
```
The error message in cases like this is
`Resolution error: sub type has a weaker constraint for minItems than base type for minItems.`
[Back to the top](#bookmark-a)
## Declaring an undefined type in a header
This error occurs when a non-existent type is specified in a header. To fix the error, specify a
type that is defined in the RAML specification.
Error message
`Cannot declare unresolved parameter`
In the incorrect example below, the value for the header `myHeader` has a typo. It is specified as
`someTypo`, not as `someType`.
Table 3. Incorrect Example vs. Corrected Example | Incorrect | Correct |
|---|
#%RAML 1.0
title: test
types:
SomeType: string
/endpoint:
post:
headers:
MyHeader: someTypo | #%RAML 1.0
title: test
types:
SomeType: string
/endpoint:
post:
headers:
MyHeader: someType |
[Back to the top](#bookmark-a)
## Using a Forward Slash in a URI Parameter
A URI parameter that contains a forward slash (/) is invalid.
In this example, the `example` for the URI parameter `transaction-Date` would cause the parser to
display an error message:
```none
#%RAML 1.0
title: test
/endpoint:
uriParameters:
transaction-Date:
example: 01/02/2018
```
The error message in cases like this is
`Value '01/02/2018' of uri parameter must not contain '/' character.`
[Back to the top](#bookmark-a)
## Incorrect Formats for `datetime` Types
Formats for `datetime` types that do not use "rfc3339" or "rfc2616" are invalid.
The following example causes the parser to display an error message:
```none
#%RAML 1.0
title: test
types:
MyType:
type: datetime
format: "rfc3338"
```
The error message in cases like this is
`Invalid format value for datetime, must be ‘rfc3339’ or ‘rfc2616’.`
[Back to the top](#bookmark-a)
## Absolute Paths in RAML Fragment Projects
When adding dependencies using absolute paths (for example: `(!include /examples/200.json)`) in RAML
Fragment projects, you get a validation error: `Resource /examples/200.json not found`.
You must always use relative paths for RAML Fragment Projects, for example:
`(!include ../examples/200.json)`.
[Back to the top](#bookmark-a)
---
product: Design Center
---
# Create an API Specification with the Text Editor
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
You can use API Designer’s text editor to create API specifications directly in RAML 0.8, RAML 1.0,
OAS 2.0, OAS 3.0, AsyncAPI 2.6, and AsyncAPI 2.0. You can create OAS and AsyncAPI API specifications
as JSON or YAML files.
## Before You Begin
Within Anypoint Platform, your user ID must be assigned the _Design Center Developer_ permission.
## Procedure
1. On the **Projects** page in Design Center, click **Create new**.
2. Select **New API Specification** to create a REST API or **New AsyncAPI** to create an AsyncAPI.
3. In the **New API Specification** or **New AsyncAPI** dialog, name your project.
You can change the name (but not the extension) later, if you want to.
4. To start creating a REST API specification:
1. Select the **I’m comfortable designing it on my own** option.
2. Choose either the RAML or OAS specification.
API Designer creates the stubs of your API specification using the specification type and
version you choose.
By default, API Designer creates a RAML 1.0 file. You can change the file to RAML 0.8 or OAS
after the project is created. Projects for creating API specifications can contain a mix of
RAML, OAS, and other types of files.
5. To start creating an AsyncAPI specification:
- Select either YAML or JSON as the project language.
The text editor opens.
The API Designer text editor is divided into panels:
- The left panel lists the files and dependencies in your project.
The stub specification file is listed and set as the root file of the project. You can change the
name (but not the extension) of this file by clicking the overflow menu icon
()
beside the specification name and selecting **Rename**.
The left panel also lists the file `exchange.json`, which is a file that contains metadata
required by Anypoint Exchange at the time that you publish your project to Exchange. This file is
read-only.
> [!TIP] You can create more than one API specification or related file in a single project. Click
> the plus sign in the Files panel to create a new file.
>
> If you do create more than one specification file, you must specify one of them as the root file
> of your project.
For more information about adding Exchange dependencies, see "Adding Dependencies to an
API-Specification Project", which is linked to from the **See also** section at the end of this
topic.
- The middle panel displays the editor in which you create the API specification. Appearing in the
editor when you create a project or start a new API specification are the first two lines of an
API specification file, depending on which type of specification you select when you created the
project. You can change these lines (as well as the file extension) if you want to switch from
RAML to OAS or vice-versa.
- The right panel lists the types and resources that are in the API specification that is in the
middle panel.
- The bottom panel expands to show any project errors. The **Project Errors** panel shows any
functional errors for your API specifications and any conformance messages if you are using API
Governance and the API specification you are editing has rulesets applied to it as dependencies.
## The Editor
While working in the editor, you can use a large number of commands to navigate through and
manipulate the content of your API specification. Press **F1** to see a list of these commands,
along with keyboard shortcuts for most of the commands.
You can also perform these tasks:
- **Import files and API fragments into your project**
You can import either separate files or files bundled in .zip files. The files can be on your
computer or you can specify a URL for them if they are located online.
For more information about importing files and steps for how to import them, see "Import Files
into an API Project", which is linked to from the **See also** section at the end of this topic.
For information about adding API fragments to your project, see "Add a RAML API Fragment to an
API-Specification Project as a Dependency", which is linked to from the **See also** section at
the end of this topic.
> [!WARNING] File uploads are restricted to supported formats.
- **Simulate calls to your API**
When you draft a REST API specification, you can simulate calls to the specified endpoints.
For more information, view the topic "Simulate Calls to an API", which is linked to from the **See
also** section at the end of this topic.
- **Export your API project or specification**
At any time, you can export your project as a ZIP file. Click the gear icon in the top-right
corner of the text editor and select **Download Project**.
- **Download files**
Click the dots to the right of the file name and select **Download**.
- **Download files in a different format**
Click the dots to the right of the file name of a specification and select **Download as**. You
can download your specification in one of the other supported formats. If your specification is in
RAML, you can download it in OAS YAML or in OAS JSON. If your specification is in OAS, you can
download it in RAML 0.8 or in RAML 1.0.
The files downloaded through this option are not guaranteed to be valid. This option is intended
to provide the basis for the development of a new specification or the continuation of the
development of the original specification in a new format.
## What to Do Next
If you are satisfied with your API specification, you can publish it to Exchange. See
[Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish).
## See Also
- [Import Files into an API Project](https://docs.mulesoft.com/design-center/design-import-files)
- [AsyncAPI Specifications](https://docs.mulesoft.com/design-center/design-async-api)
- [Add a RAML API Fragment to an API-Specification Project as a Dependency](https://docs.mulesoft.com/design-center/design-add-api-dependency)
- [Simulate Calls to an API](https://docs.mulesoft.com/design-center/design-mocking-service)
- [Root Files in Projects in the Text Editor](https://docs.mulesoft.com/design-center/design-change-root-file)
- [Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish)
- [Rename an Open Project](https://docs.mulesoft.com/design-center/design-rename-project)
- [Delete an Open Project](https://docs.mulesoft.com/design-center/design-delete-project)
- [API Governance Documentation](https://docs.mulesoft.com/api-governance/)
---
product: Design Center
---
# Create an API Specification with the Visual API Editor
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
You can use API Designer’s visual API editor to scaffold API specifications in RAML 1.0 or in OAS
2.0 or 3.0 (JSON). You do so by populating language-neutral forms.
## Before You Begin
Within Anypoint Platform, your user ID must be assigned the _Design Center Developer_ permission.
## About this task
The visual API editor is divided into three panels:
### The Left Panel
This panel displays the name of the API specification being developed. It also provides controls
that allow you to create resources, data types, and security schemes. These components all are
included within the body of the specification and are not created as separate files.
### The Middle Panel
This panel presents the forms in which you specify the properties of the components of the
specification. When the editor first opens, it displays a form for specifying the main properties of
the specification and for documenting it. Click on the name of an item in the left panel to open its
form in the middle panel.
### The Right Panel
This displays the RAML Viewer and the OAS Viewer, both of which are read-only. Click the tabs at the
bottom of the panel to switch between them. These viewers display the current draft of the
specification in either RAML 1.0 or OAS 3.0. As you enter values in the forms that appear in the
middle panel, the draft is updated with the values.
This panel also lets you run the mocking service to test endpoints that you have set up.
## Procedure
1. On the **Projects** page in Design Center, click **Create new**.
2. Select **New API Specification**.
3. In the **New API Specification** dialog, name your project.
You can change the name later, if you want to.
4. Select the option **Guide me through it** to use the visual API editor.
5. Click **Create API Spec.**
_Result:_ The visual API editor opens.
As you make progress, you can run the mocking service to simulate calls to your API
specification. For more information, view the topic "Simulate Calls to an API", which is listed
in the **See Also** section at the end of this topic.
If at any time you want to edit the specification directly or customize it (import RAML
fragments and more), click **Edit RAML** or **Edit OAS** to switch to the API editor. After you
switch, however, you cannot switch back to the visual API editor to continue creating the API
specification.
## What to Do Next
If you are satisfied with your API specification, you can publish it to Exchange in RAML 1.0. See
[Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish).
Alternatively, you can customize the specification in the API editor by clicking **Edit RAML** or
**Edit OAS**.
## See Also
- [Simulate Calls to an API](https://docs.mulesoft.com/design-center/design-mocking-service)
- [Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish)
- [Rename an Open Project](https://docs.mulesoft.com/design-center/design-rename-project)
- [Delete an Open Project](https://docs.mulesoft.com/design-center/design-delete-project)
---
product: Design Center
---
# Create and Publish an API Fragment in the Text Editor in API Designer
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
You can create API fragments directly in RAML, OAS 3.0, and JSON Schema with the help of code
suggestions that appear within the text editor.
## About This Task
An API fragment is a document that has a version and an identifier, but is not in itself a complete
specification.
When creating a RAML API fragment you can choose one of the following types defined by RAML.org. See
the RAML 0.8 or 1.0 specification (depending on which you want to use) for descriptions of the
types:
- Trait
- Resource Type
- Library
- Data Type
- User Documentation
- Example
- Annotation Type
- Security Scheme
To support OAS 3.0 fragment externalization, API Fragments support OAS 3.0 components and JSON
Schema:
- Component (YAML)
- Component (JSON)
- JSON Schema
OAS 3.0 components should contain only the reusable `component` objects for the different aspects of
the OAS.
## Procedure
1. On the **Projects** page in Design Center, click **Create +**.
2. Select **New Fragment**.
3. In the **New Fragment** dialog, type a name for the Fragment project.
4. Select the API specification format.
You can choose between RAML 1.0, OAS 3.0 and JSON Schema format.
If you choose RAML 1.0, you can select it’s fragment type.
You can change the name or fragment type later, if necessary.
5. Select the type of API fragment that you want to create and click **Create Fragment**.
_Result:_ The text editor opens. The editor is divided into three panels:
- The left panel lists the files in your project.
You can create new files by clicking **+**, and then **New file**. Select the API format of
the file between RAML 1.0, OAS 3.0, JSON schema, or other. Select the file type if needed,
name your file, and click **Create**.
By default, the editor creates a file that has the same name as the project. This file is set
as the root file of the project.
You can set YAML, RAML, or JSON schema files as your root file.
The left panel also lists the file `exchange.json`, which is a file that contains metadata
required by Anypoint Exchange at the time that you publish your project to Exchange. This file
is read-only.
- The middle panel displays the editor in which you create your API fragment.
- The right panel lists the types and resources that are in the API fragment displayed in the
middle panel.
6. Draft your API fragment.
The text editor suggests RAML nodes, methods, and other elements that you can add at the
location of your cursor.
You can import files into your project, either separately or bundled in .zip files. The files
can be RAML 1.0 files, JSON files, OpenAPI Specification (OAS) 2.0, or OAS 3.0 files. The files
can be on your computer or you can specify a URL for them if they are located online.
> [!WARNING] File uploads are restricted to supported formats.
## What to Do Next
You can publish the API fragment to Anypoint Exchange.
1. Click the **Publish** button that is in the top-right corner of the text editor, and then click
**Publish to Exchange**.
2. Specify a version number for the project, which Exchange treats as an _asset_. This number is
displayed in Exchange in the **Version** section of the right pane in the page for the project.
In Anypoint Exchange, you can see the asset version of your API-fragment project by clicking **View
versions**.
After you publish the API-fragment project, other developers can include its fragments as
dependencies in their own API-specification projects.
When you publish the API-fragment project, Exchange automatically creates an API portal for it.
## OAS Components Limitations
The following list displays OAS 3.0 limitations you must consider when writing your API Fragments:
- Valid fields at the document root level are: `openapi`, `info`, `components`, and `paths`.
- Valid fields in the `info` object are `title` and `version`.
- The `paths` key must be an empty object.
## See Also
- [Import Files into an API Project](https://docs.mulesoft.com/design-center/design-import-files)
- [Exchange Public Portals](https://docs.mulesoft.com/exchange/about-portals)
- [Root Files in Projects in the Text Editor](https://docs.mulesoft.com/design-center/design-change-root-file)
- [Rename an Open Project](https://docs.mulesoft.com/design-center/design-rename-project)
- [Delete an Open Project](https://docs.mulesoft.com/design-center/design-delete-project)
- [Adding Dependencies to an API-Specification Project](https://docs.mulesoft.com/design-center/design-add-api-dependency)
---
product: Design Center
---
# Create and Publish an API Specification or Fragment from an External File
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
Use API Designer to create a new API specification or an API fragment from an existing external
file. API Designer supports importing from JSON, RAML, or YML files. You can also import API
specifications and fragments from an existing project.
## Procedure
1. On the **Projects** page of Design Center, click the **Create new** button and then click
**Import from File**.
2. Specify a name to give to the imported project.
3. Click **Choose file**, then browse your filesystem for the you want to import.
You can create a new project from one following file types:
- JSON
- RAML
- YAML
- a ZIP file that contains an existing project.
4. Click **Import as…** then choose either **API Specification** or **API Fragment**.
API Designer opens the API specification or fragment in a new project using the text editor. API
Designer uses the existing name for each file of the project. You can change these names as
necessary.
## Modifying Your API Specification or Fragment
While you are working in the editor, you can navigate through and manipulate the content of your
specification. Press F1 at any time to see a list of them. This list also displays keyboard
shortcuts for most of the commands.
You can also perform these tasks:
Import files and API fragments into your project
You can import files, either separately or bundled in ZIP files. The files can be RAML 1.0 files,
JSON files, or OpenAPI Specification (OAS) 2.0 or 3.0 files (either JSON or YAML). The files can be
on your computer or you can specify a URL for them if they are located online.
For more information about importing files and steps for how to import them, see "Import Files into
an API Project", which is linked to from the **See also** section at the end of this topic.
For information about adding API fragments to your project, see "Add a RAML API Fragment to an
API-Specification Project as a Dependency", which is linked to from the **See also** section at the
end of this topic.
Simulate calls to your API
Even while you are drafting an API specification, you can simulate calls to endpoints for which you
have specified:
- An HTTP status code the API returns, if successful
- An example of data the actual implementation would return
For more information, see [Simulate Calls to an API](https://docs.mulesoft.com/design-center/design-mocking-service).
Export your API project or specification
At any time, you can export your project as a ZIP file. Click the gear icon in the top-right corner
of the text editor and select **Download Project**.
Download files
Click the dots to the right of the file name and select **Download**.
Download files in a different format
Click the dots to the right of the file name of a specification and select **Download as**. You can
download your specification in one of the other supported formats. If your specification is in RAML,
you can download it in OAS YAML or in OAS JSON. If your specification is in OAS, you can download it
in RAML 0.8 or in RAML 1.0.
The files downloaded through this option are not guaranteed to be valid. This option is intended to
provide the basis for the development of a new specification or the continuation of the development
of the original specification in a new format.
## What to Do Next
If you are satisfied with your API specification, you can publish it to Exchange. See
[Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish).
---
product: Design Center
---
# Creating New GitHub Repositories Synchronized from an Existing Projects
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
You can create a new GitHub repository and synchronize it with an existing API Designer project.
## Before You Begin
Before you synchronize a new repository and a project, ensure you have:
- The Design Center Developer permission within Anypoint Platform
- [Installed and authorized](https://docs.mulesoft.com/design-center/design-ghs-install-authorize) the GitHub Synchronization application
- Signed into GitHub
## Synchronize A New Repository and A Project
1. In the Design Center **Projects** list, click the table row containing a project to synchronize
with GitHub.
2. In the details panel, click the **Sync with GitHub** button.
3. In the **Enable Sync with GitHub** dialog, select an organization from the **GitHub
Organization** list dropdown.
> [!NOTE] The **GitHub Organization** list remains empty if the GitHub Synchronization
> application is not installed. See
> [Install and Authorize the MuleSoft GitHub Synchronization Application](https://docs.mulesoft.com/design-center/design-ghs-install-authorize).
4. Specify a name for the new repository.
5. Click **Sync**.
You are navigated to the Design Center **Projects** page. A **Sync Status** indicator appears in
the **Details** pane along with buttons that enable you to manage a GitHub repository and
disable synchronizing.
## See Also
- [Create an API Specification with the Text Editor](https://docs.mulesoft.com/design-center/design-create-publish-api-raml-editor)
- [Helpful Features in the Text Editor](https://docs.mulesoft.com/design-center/design-helpful-features-text-editor)
- [Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish)
---
product: Design Center
---
# Creating New Projects Synchronized from Existing GitHub Repositories
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
You can create a new API Designer project and synchronize it with an existing GitHub repository.
## Before You Begin
Before you create and synchronize a project, ensure you have:
- The Design Center Developer permission within Anypoint Platform
- [Installed and authorized](https://docs.mulesoft.com/design-center/design-ghs-install-authorize) the GitHub Synchronization application
- Signed into GitHub
## Synchronize A New Project
1. On the Design Center **Projects** page, click **Create new**.
2. Select **Sync from existing GitHub Repo**.
3. In the **New Project** dialog, specify a name in the **Project Name** field.
4. Select an organization and repository from which to synchronize your new project.
> [!NOTE] The **GitHub Organization** dropdown list displays GitHub organizations that have the
> GitHub Synchronization application installed. No organizations or repositories are listed if
> the application is not installed.
5. Click **Import As**.
6. Choose the type of API project to sync: **API Specification** or **API Fragment**.
You are navigated to the new project’s text editor.
## See Also
- [Create an API Specification with the Text Editor](https://docs.mulesoft.com/design-center/design-create-publish-api-raml-editor)
- [Helpful Features in the Text Editor](https://docs.mulesoft.com/design-center/design-helpful-features-text-editor)
- [Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish)
---
product: Design Center
---
# Creating New Projects Synchronized with New GitHub Repositories
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
When creating an API Designer project, you can also create a GitHub repository and synchronize the
repository with your project.
## Before You Begin
Before you create and synchronize a project, ensure you have:
- The Design Center Developer permission within Anypoint Platform
- [Installed and authorized](https://docs.mulesoft.com/design-center/design-ghs-install-authorize) the GitHub Synchronization application
- Signed into GitHub
## Synchronize A New Project
1. On the Design Center **Projects** page, click **Create new**.
2. Select **New API Spec**.
3. In the **New API Spec** dialog, specify an API title.
4. Select **I’m comfortable with designing it on my own**.
5. Click the **Sync this project with an external GitHub repository** checkbox.
6. In the expanded dialog, select an organization from the **GitHub Organization** list.
> [!NOTE] The **GitHub Organization** list remains empty if the GitHub Synchronization
> application is not installed.
7. If necessary, specify a new name for the repository.
8. Click **Create API Spec**.
You are navigated to the new project’s text editor.
In addition to synchronizing GitHub repositories when creating API specifications, you can
synchronize a new GitHub repository when creating fragments and importing APIs.
## See Also
- [Create an API Specification with the Text Editor](https://docs.mulesoft.com/design-center/design-create-publish-api-raml-editor)
- [Helpful Features in the Text Editor](https://docs.mulesoft.com/design-center/design-helpful-features-text-editor)
- [Publish an API Specification](https://docs.mulesoft.com/design-center/design-publish)
---
product: Design Center
---
# Delete a Project
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
You can delete an API-specification project or an API-fragment project. If you have already
published a project, deleting it in API Designer does not delete it from Anypoint Exchange.
> [!IMPORTANT] The deletion of a project is final. Deleting a project does _not_ move it to a
> **Trash** folder from which you can restore the project if you change your mind.
## Procedure
To delete a project, use one of these methods:
- If the project is not open, select the project in Design Center’s **Projects** page, and then
click the Delete icon in the top-right corner of the page.
- If the project is open, click the gear icon in API Designer’s top-right corner and then select
**Delete**.
---
product: Design Center
---
# Design Center Release Notes
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
The following release notes are provided for Design Center:
- [API Designer Release Notes](https://docs.mulesoft.com/release-notes/design-center/design-center-release-notes)
- [API Mocking Service Release Notes](https://docs.mulesoft.com/release-notes/api-mocking-service/api-mocking-service-release-notes)
## See Also
- [Known Issues](https://help.salesforce.com/s/issues)
---
product: Design Center
---
# Designing API Specs and Fragments
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
Use API Designer to create, design, test, and publish new API Specifications.
## Design Using the Text or Visual Editor
You can use either [the text editor](https://docs.mulesoft.com/design-center/design-create-publish-api-raml-editor) or
[the Visual Editor](https://docs.mulesoft.com/design-center/design-create-publish-api-visual-editor) to create API specifications.
With the text editor, you can:
- Design according to best practices with a context-aware shelf that auto-populates with the
appropriate methods, resources, parameters, and security components.
- Include RAML API fragments, such as security schemas and data types, from Exchange or write your
own.
- Apply rulesets from Exchange to validate the governance conformance of your projects.
- Import existing API specifications.
With the visual editor, you can:
- Create a specification for use cases in which you do not need to include RAML fragments.
- Scaffold a specification that you can complete and customize in the text editor.
---
product: Design Center
---
# Differences for OAS 3.0 in Rendered Documentation
> For the full documentation index, see: https://docs.mulesoft.com/llms.txt
The right pane of the text editor in API Designer displays the documentation that is written into
API specifications. Documentation is rendered identically for REST API specifications written in
RAML or OAS 2.0. However, documentation for API specifications written in OAS 3.0 can include
multiple server definitions as well as links and callbacks.
## Documentation for Definitions of Multiple Servers
OAS 3.0 enables you to define servers by using the `servers` field. You can define servers globally
at the top of a specification, locally for endpoints, and locally for methods. Local definitions
override the definitions set at the next higher level in the specification’s hierarchy. Definitions
set locally for methods override definitions set at endpoints and globally. Definitions set locally
for endpoints override definitions set globally.
The following example API specification demonstrates different ways, indicated by ten callouts
(1-10), that you can set server definitions. After the example API specification, the documentation
for the portion of the API at each callout is illustrated with a screenshot.
openapi: '3.0.2' info: title: Multi-server Cemo API version: '1.0' servers: **(1)**
- url: https://{customerId}.saas-app.com:{port}/v2 variables: customerId: default: demo description:
Customer ID assigned by the service provider port: enum: - '443' - '8443' default: '443'
- url: https://{region}.api.company.com variables: region: default: westus enum: - westus -
eastus2 - westcentralus - westeurope - southeastasia
- url: https://api.company.org/data/2.5/ description: Production server
- url: http://beta.api.company.org/data/2.5/ description: Beta server paths: /default:**(2)**
description: A default path to the API get:**(3)** summary: "The get method for /default"
responses: 200: description: Successful response /duplicated:**(4)** description: Has some of the
default servers servers:
- url: https://api.company.org/data/2.5/ description: Production server
- url: http://beta.api.company.org/data/2.5/ description: Beta server get:**(5)** summary: "The
get method for /duplicated" responses: 200: description: Successful response /files:**(6)**
description: File upload and download operations servers:
- url: https://files.example.com description: Override base path for all operations with the
/files path get:**(7)** summary: "The get method for /files" responses: 200: description:
Successful response /ping:**(8)** servers:
- url: https://endpoint.example.com description: Override base path servers get:**(9)** servers:
- url: https://echo.example.com description: Override base path for the GET /ping operation
[...]
